package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.*;

/**
 * @author leon on 27/12/2018.
 */
public class Food {

    public Food(){

    }

    ArrayList<Spice> spices= new ArrayList<>();


    public List<Spice> getAllSpices() {
        return spices;
    }


    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount() {
      LinkedHashMap<SpiceType, Integer> spiceCount = new LinkedHashMap<>();
        for (Spice s : spices) {
            spiceCount.put((SpiceType) s.getClass(), s.getSpiciness());
        }
        for (Spice s : spices) {
            s.setSpiciness(0);
        }
        return spiceCount;
    }



    public void applySpice(Spice spice) {
        if(!spices.contains(spice)){
            spices.add(spice);
        }
        spice.setSpiciness(spice.getSpiciness()+1);
    }
}
